var Movies = null;
var MovieSize = 50;
var BaseURL = "http://movies.yahoo.com";
var scroller = null;

var waitTimer = null;
var waitCount = 0;

// http://www.amazon.com/gp/associates/link-types/searchbox.html?tag=wobsofweewidg-20&creative=374001&campaign=211041&mode=blended&keyword=Doom&Submit.x=14&Submit.y=11&Submit=Go

function init() {
    setTimeout( _startWaitTimer, 0 );
    for ( var i = 0; i < 12; i++ ) {
        (new Image()).src = "Images/Wait" + i + ".png";
    }

    var loader = new SiteLoader( BaseURL + "/mv/boxoffice/", parseHTML, debug );
    loader.start();

    scroller = new Scroller( document.getElementById( "tableContainer" ),
                             document.getElementById( "rankTable" ),
                             document.getElementById( "track" ),
                             document.getElementById( "thumb" ) );
    //setTimeout( parseHTML, 0 );

    //parseHTML( contents );
}

function parseHTML( html ) {
    if ( html == null ) html = contents;
    var epos = html.indexOf( "</SELECT>" );
    var p1 = html.indexOf( "<table", epos );
    var p2 = html.indexOf( "</table>", p1 );

    var parser = new _HTMLParser();
    var htmldoc = parser.parse( html.substring( p1, p2 + 8 ) );

    Movies = new Array();
    for ( var count = 2; count < MovieSize + 2; count ++ ) {
        var row = getElementAt( htmldoc.firstChild, "TABLE/TR," + count );
        if ( row == null ) {
            break;
        }

        var info = new MovieInformation( row );
        Movies.push( info );
        debug( info );
    }

    createTable();
    setTimeout( _loadAllLinks, 50 );
    return Movies;
}

function _loadAllLinks() {
    if ( Movies == null ) return;
    for ( var i = 0; i < Movies.length; i++ ) {
        Movies[ i ].loadLinks();
    }
}

function _startWaitTimer() {
    if ( waitTimer ) {
        debug( "already running" );
        return;
    }

    var div = document.getElementById( "wait" );
    if ( div ) {
        div.style.display = "block";
        waitTimer = setInterval( _tickWaitTimer, 66 );
        _tickWaitTimer();
    }
}

function _tickWaitTimer() {
    //debug( "ticking " + waitCount );
    var div = document.getElementById( "wait" );
    if ( div ) {
        div.src = "Images/Wait" + waitCount + ".png";
    } else {
        debug( "no debug" );
    }
    waitCount ++;
    if ( waitCount >= 12 ) waitCount = 0;
}

function _stopWaitTimer() {
    clearInterval( waitTimer );
    waitTimer = null;
    var div = document.getElementById( "wait" );
    div.style.display = "none";
}

function _createImage( src, width, height ) {
    var img = document.createElement( "img" );
    if ( src ) {
        img.src = src;
    } else {
        img.src = "";
    }
    img.width = width;
    img.height = height;
    return img;
}

function createTable() {
    var table = document.getElementById( "rankTable" );
    if ( Movies == null || Movies.length == 0 ) return;
    while ( table.lastChild ) table.removeChild( table.lastChild );
    for ( var i = 0; i < Movies.length; i+= 2 ) {
        var minfo1 = Movies[ i ];
        var minfo2 = Movies[ i + 1 ];
        var row_odd = document.createElement( "tr" );
        var row_even = document.createElement( "tr" );
        var icon1 = document.createElement( "td" );
        var icon2 = document.createElement( "td" );
        var info1 = document.createElement( "td" );
        var info2 = document.createElement( "td" );
        info1.setAttribute( "class", "oddRow" );
        info2.setAttribute( "class", "evenRow" );
//         icon1.setAttribute( "class", "oddRow" );
//         icon2.setAttribute( "class", "evenRow" );
        row_even.setAttribute( "align", "right" );

        icon1.setAttribute( "valign", "top" );
        icon2.setAttribute( "valign", "bottom" );
        icon1.setAttribute( "class", "leftIcon" );
        icon2.setAttribute( "class", "rightIcon" );
        icon1.setAttribute( "rowspan", "2" );
        icon2.setAttribute( "rowspan", "2" );

        minfo1.iconDivision = icon1;
        minfo2.iconDivision = icon2;

        minfo1.setElements( info1, icon1 );
        minfo2.setElements( info2, icon2 );
        minfo1.write();
        minfo2.write();

        row_odd.appendChild( icon1 );
        row_odd.appendChild( info1 );
        row_odd.appendChild( icon2 );
        row_even.appendChild( info2 );

        table.appendChild( row_odd );
        table.appendChild( row_even );
    }

    if ( scroller ) scroller.refresh();
}

function debug( message ) {
    if ( message == null ) return;
//     if ( window.Logger ) {
//     Logger.log( message.toString() );
//     }
    var div = document.getElementById( "debug" );
    div.appendChild( document.createTextNode( message.toString() ) );
    div.appendChild( document.createElement( "br" ) );
}


function MovieInformation( dataRow ) {
    this.title = null;
    this.rankingTW = null;
    this.rankingLW = null;
    this.distributor = null;
    this.grossTW = null;
    this.grossAC = null;
    this.weeks = null;
    this.theaters = null;
    this.url = null;
    this.link = null;
    this.available = false;
    this.imageSrc = "Images/Cinema.png";
    this.division = null;
    this.iconDivision = null;
    this.reviewURL = null;

    if ( dataRow ) {
        try {
            children = dataRow.childNodes;
            this.rankingTW = getInsideTexts( dataRow, "", "TD" );
            this.rankingLW = getInsideTexts( dataRow, "", "TD,2" );
            this.title = getInsideTexts( dataRow, "", "TD,3" );
            this.url = BaseURL + getElementAt( dataRow, "TD,3/A" ).attributes.item( 0 ).value;
            this.distributor = getInsideTexts( dataRow, "", "TD,4" );
            this.grossTW = getInsideTexts( dataRow, "", "TD,5" );
            this.grossAC = getInsideTexts( dataRow, "", "TD,6" );
            this.weeks =getInsideTexts( dataRow, "", "TD,7" );
            this.theaters = getInsideTexts( dataRow, "", "TD,8" );
            this.available = true;
        } catch ( e ) {
            debug( e );
        }
    }
}


MovieInformation.prototype.toString = function() {
    var output = this.rankingTW + " " + this.rankingLW + " : " + this.title + " / " + this.url;
    return output;
};

MovieInformation.prototype.loadLinks = function() {
    var loader = new SiteLoader( this.url, MovieInformation__parseHTML, debug, this );
    loader.start();
};

MovieInformation.prototype.refresh = function() {
    this.write();
    if ( SiteLoader.prototype.existsRunningProcess() == false ) {
        _stopWaitTimer();
    }
};

MovieInformation.prototype.setElements = function( div, idiv ) {
    this.division = div;
    this.iconDivision = idiv;
};

function _createAnchor( text, url ) {
    var anchor = document.createElement( "a" );
    if ( window.widget ) {
        anchor.setAttribute( "onclick", "widget.openURL('" + url + "')" );
    } else {
        anchor.setAttribute( "href", url );
    }
    anchor.appendChild( document.createTextNode( text ) );
    return anchor;
}

MovieInformation.prototype.write = function() {
    if ( this.division == null ) return;
    while ( this.division.lastChild ) {
        this.division.removeChild( this.division.lastChild );
    }
    var e1 = document.createElement( "div" );
    e1.setAttribute( "class", "title" );
    var number = document.createElement( "span" );
    number.setAttribute( "class", "rankNumber" );
    number.appendChild( document.createTextNode( this.rankingTW ) );
    e1.appendChild( number );
    e1.appendChild( _createAnchor( this.title, this.url ) );//document.createTextNode( this.title ) );
    this.division.appendChild( e1 );

    var e2 = document.createElement( "div" );
    e2.setAttribute( "class", "links" );
    if ( this.reviewURL ) {
        e2.appendChild( _createAnchor( "Reviews", this.reviewURL ) );
    }

    var keyword = escape( this.title );
    var url_amazon = "http://www.amazon.com/gp/associates/link-types/searchbox.html?tag=wobsofweewidg-20&creative=374001&campaign=211041&mode=blended&keyword=" + keyword + "&Submit.x=14&Submit.y=11&Submit=Go";
    e2.appendChild( _createAnchor( "Products", url_amazon ) );
    //e2.appendChild( document.createTextNode( "Review Products" ) );
    this.division.appendChild( e2 );

    if ( this.iconDivision == null ) return;
    while ( this.iconDivision.lastChild ) {
        this.iconDivision.removeChild( this.iconDivision.lastChild );
    }
    var img = _createImage( this.imageSrc, 45, 60 );
    this.iconDivision.appendChild( img );
};

// MovieInformation.prototype.writeInformation = function( td ) {
//     var e1 = document.createElement( "div" );
//     e1.setAttribute( "class", "title" );
//     e1.appendChild( document.createTextNode( this.title ) );
//     td.appendChild( e1 );

//     var e2 = document.createElement( "div" );
//     e2.setAttribute( "class", "links" );
//     e2.appendChild( document.createTextNode( "Review Products" ) );
//     td.appendChild( e2 );
// };

function MovieInformation__parseHTML( text, minfo ) {

    // review
    var re_review = new RegExp( "<a\\s+[^>]+>\\d+\\sreviews?</a>", "img" );
    var re_href = new RegExp( "href=((\"([^\"]+)\")|([^\"'\\s][^\\s]+))" );
    mr = re_review.exec( text );
    if ( mr ) {
        var mref = re_href.exec( mr[ 0 ] );
        if ( mref ) {
            if ( mref[ 2 ] == null || mref[ 2 ].length == 0 ) {
                minfo.reviewURL = mref[ 4 ];
            } else {
                minfo.reviewURL = mref[ 3 ];
            }
        }
        debug( minfo.reviewURL + " " + mref );
    } else {
        debug( "no reviews" );
    }

    // find image
    var re_img = new RegExp( "<img[^>]+>", "img" );
    var re_width  = new RegExp( "width=\"?(\\d+)\"?", "m" );
    var re_height = new RegExp( "height=\"?(\\d+)\"?", "m" );
    var re_src = new RegExp( "src=((\"([^\"]+)\")|([^\"'\\s][^\\s]+))", "m" );
    debug( "finding images of " + escape( minfo.title ) );
    var m = re_img.exec( text );
    while ( m ) {
        var mw = re_width.exec( m[ 0 ] );
        var ms = re_src.exec( m[ 0 ] );
        var mh = re_height.exec( m[ 0 ] );
        //debug( m );//mw + ", " + mh + ", " + ms );
        if ( mw != null && ms != null && mh != null ) {
            var width = parseInt( mw[ 1 ] );
            var height = parseInt( mh[ 1 ] );
            var ratio = width / height;
            if ( height > 100 && ratio > 0.65 && ratio < 0.75 ) {
                var src = ms[ 3 ];
                if ( ms[ 2 ] == null || ms[ 2 ].length == 0 ) {
                    src = ms[ 4 ];
                }
                if ( minfo ) minfo.imageSrc = src;
                debug( "size = ( " + mw[ 1 ] + ", " + mh[ 1 ] + " )  src = " + src );
                break;
            }
        }
        m = re_img.exec( text );
    }
    if ( minfo ) minfo.refresh();
}
